// EventQ.cpp

#include <conio.h>
#include <dos.h>
#include <stdio.h>

#include "EventQ.h"

#ifdef TEST_EVENTQ

main()
{
	EventQ Queue ;
	
	for(;;)
	{
		switch ( Queue . GetEvent() )
		{
			
			case KEY_PRESS :
				{
					unsigned char c ;
					if ( ( c = Queue . GetKey() ) == 0x1b )
						return ( 0 ) ;
					printf ( "\nKey Pressed(0x%02x)\n", c ) ;
				}
				break ;
			case MOUSE_LCLICK :
				{
					int x, y ;
					
					Queue . GetClickPos ( &x, &y ) ;
					printf ( "\nLeft button click at (%d,%d)\n", x, y ) ;
				}
				break ;
			case TIMER_TICK :
				printf ( "." ) ;
				fflush ( stdout ) ;
				break ;
			default :
				;
		}
	}
}

#endif

// EventQ

EventQ::EventQ()
{
	// Especially ugly hack here. Getting the DOS time count at 0040:006c. 
	// It's fast but won't work with anything but the Large model. Change
	// it to a slow BIOS call in GetEvent() if it makes you queasy.
	SysTime = (unsigned long *)( ( 0x40 << 4 ) | 0x6c ) ;
	MyTime = *SysTime ;
	union _REGS regs ;
	regs . x . ax = 0 ;
	_int86 ( 0x33, &regs, &regs ) ;
	if ( regs . x . ax )
	{
		GotMouse = 1 ;
		regs . x . ax = 1 ;
		_int86 ( 0x33, &regs, &regs ) ;
	}
	else
		GotMouse = 0 ;
}

EventQ::~EventQ()
{
}

event EventQ::GetEvent()
{
	// Get key press
	if ( kbhit() )
	{
		int c ;
		if ( ( c = getch() ) != 0 )
			KeyPressed = c ;
		else
			KeyPressed = getch() | 0x80 ;
		return ( KEY_PRESS ) ;
	}
	
	// Get Mouse click
	if ( GotMouse )
	{
		union _REGS regs ;
		regs . x . ax = 5 ;
		regs . x . bx = 0 ;
		_int86 ( 0x33, &regs, &regs ) ;
		if ( regs . x . bx )
		{
			MouseX = regs . x . cx ;
			MouseY = regs . x . dx ;
			return ( MOUSE_LCLICK ) ;
		}
	}
	if ( *SysTime - MyTime >= 5 )
	{
		MyTime = *SysTime ;
		return ( TIMER_TICK ) ;
	}
	
	return ( NO_EVENT ) ;
}

int EventQ::GetJsValue()
{
	return ( JsValue ) ;
}

int EventQ::GetKey()
{
	return ( KeyPressed ) ;
}

void EventQ::GetClickPos ( int *x, int *y )
{
	*x = MouseX ;
	*y = MouseY ;
}
