// Main.cpp

#include <graph.h>
#include <stdio.h>

#include "EventQ.h"
#include "Stepper.h"

// App
class App
{
	private:
		Port *a_port ;
		Stepper *a_step ;
		EventQ *a_queue ;
	public:
		App() ;
		~App() ;
		void ProcEvent() ;
} ;

App::App()
{
	_setvideomode ( _VRES16COLOR ) ;
	
	if ( _registerfonts ( "*.FON" ) <= 0 )
		_outtext ( "Error reading fonts.\n" ) ;

	char fontname [ 40 ] ;

	sprintf ( fontname, "t\'courier\'w%db", 4 ) ;
	if ( _setfont ( fontname ) < 0 )
		_outtext ( "Error setting font.\n" ) ;

	a_queue = new EventQ ;
	a_port = new Port ;
	a_step = new Stepper ( a_port, 50, 50, "Stepper", 7 ) ;
	a_step -> DrawPanel() ;
}

App::~App()
{
	delete a_queue ;
	delete a_port ;
	_unregisterfonts() ;
	_setvideomode ( _TEXTC80 ) ;
}

void App::ProcEvent()
{
	for(;;)
	{
		switch ( a_queue -> GetEvent() )
		{
			case KEY_PRESS :
				{
					int c ;
					
					c = a_queue -> GetKey() ;
					a_step -> KeyPress ( c  ) ;
					if ( c == 0x1b )
						return ;
				}
				break ;
			case MOUSE_LCLICK :
				{
					int x, y ;
					
					a_queue -> GetClickPos ( &x, &y ) ;
					a_step -> LClick ( x, y ) ;
				}
				break ;
			case TIMER_TICK :
				a_step -> TimerTick() ;
				break ;
			default :
				;
		}
	}
}


App theApp ;

int main()
{
	theApp . ProcEvent() ;
	return ( 0 ) ;
}
