// Port.cpp

// Class for the output port. Pretty silly in this case but the output routine
// treats output ports as one long stretch of bits. This is handy for special 
// cards which have several outputs. For example, I use an external latch 
// on the printer port which uses three lines as address lines giving 
// 8 x 5 = 40 output lines.

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#include "Port.h"


#define LPT1_DATA	0x378
#define LPT1_STAT	(LPT1_DATA+1)
#define LPT1_CTRL	(LPT1_DATA+2)

#ifdef TEST_PORT

int main()
{
	Port wine ;

	for(;;)
	{
		char buf [ 20 ] ;
		int val ;
		printf ( "Enter value:" ) ;
		gets ( buf ) ;
		if ( buf [ 0 ] == 0 )
			break ;
		val = atoi ( buf ) ;
		wine . OutPort ( 7, 8, val ) ;
	}
	return ( 0 ) ;
}

#endif


// Port

Port::Port()
{
}

Port::~Port()
{
}

void Port::OutPort ( int MsbNo, int NoOfBits, unsigned char value )
{
	// Output data
	_outp ( LPT1_DATA, value ) ;
}
