// Stepper.h

#ifndef _Stepper_h_
#define _Stepper_h_

#include "Port.h"

typedef enum mode { B_REW, B_REV, B_STOP, B_FWD, B_FFWD } B_MODES ;

class Stepper
{
	protected:
		Port *s_port ;
		int s_msb ;
		int s_x, s_y, s_rad ;
		int s_cen_x, s_cen_y ;
		char *s_title ;
		int spin, rev, step_inx ;
		int speed ;
		int PrevPosition, ActPosition ;
		unsigned char byte ;
		int SpeedTimer ;
		void DrawButton ( int x, int y, int w, int h, B_MODES mode, int enable ) ;
		void FwdStep() ;
		void RevStep() ;
	public:
		Stepper ( Port *port, int x, int y, char *title, int PortMsb ) ;
		~Stepper() ;
		void SetPosition ( int pos ) ;
		void ShowPosition() ;
		virtual void DrawPanel() ;
		virtual void LClick ( int x, int y ) ;
		virtual void KeyPress ( int keycode ) ;
		virtual void ExecCmd ( B_MODES cmd ) ;
		virtual void TimerTick() ;
} ;

#endif
